<?php
//First start with information about the Plugin and yourself. For example:
/*
 * @component List Manager
 * @copyright Copyright (C) 2011 Moonsoft.  
 * @license GPL 3.0
 * This program is free software: you can redistribute it and/or modify it under the terms of the 
 * GNU General Public License as published by the Free Software Foundation, either version 3 of the License, 
 * or (at your option) any later version.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * See <http://www.gnu.org/licenses/>.
 * More info www.moonsoft.es gestion@moonsoft.es 
 */
 
//To prevent accessing the document directly, enter this code:
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );



jimport('joomla.plugin.plugin');

class plgSearchListmanager extends JPlugin
{
	/**
	 * Constructor
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.5
	 */
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);		
	}



 
 
//Define a function to return an array of search areas. Replace 'nameofplugin' with the name of your plugin.
  function onContentSearchAreas()
  {
	static $areas = array(
		'listmanager' => 'Listmanager'
	);
	return $areas;
}
 
//The real function has to be created. The database connection should be made. 
//The function will be closed with an } at the end of the file.
function onContentSearch( $text, $phrase='', $ordering='', $areas=null )
{
	$limit			= $this->params->def('search_limit',		50);
	 $db            = JFactory::getDBO();
    $user  = JFactory::getUser(); 
  
    //If the array is not correct, return it:
    /*if (is_array( $areas )) {
            if (!array_intersect( $areas, array_keys( plgSearchproductoAreas() ) )) {
                    return array();
            }
    } */
   
    //Define the parameters. First get the right plugin; 'search' (the group), 'nameofplugin'. 
    $plugin = JPluginHelper::getPlugin('search', 'listmanager');
     
    //Then load the parameters of the plugin.
    //$pluginParams = new JParameter( $plugin->params );
     
    //Now define the parameters like this:
    //$limit = $pluginParams->def( 'nameofparameter', defaultsetting );
     
    //Use the function trim to delete spaces in front of or at the back of the searching terms
    $text = trim( $text );
     
    //Return Array when nothing was filled in.
    if ($text == '') {
            return array();
    }
  
  //After this, you have to add the database part. This will be the most difficult part, because this changes per situation.
  //In the coding examples later on you will find some of the examples used by Joomla! 1.5 core Search Plugins.
  //It will look something like this.
    $wheres = array();
    switch ($phrase) {
  
  //search exact
            case 'exact':
                    $text          = $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
                   /* $wheres2       = array();
                    $wheres2[]   = 'LOWER(p.info) LIKE '.$text;
                    $wheres2[]   = 'LOWER(p.name) LIKE '.$text;
                    $wheres2[]   = 'LOWER(t.info) LIKE '.$text;
                    $wheres2[]   = 'LOWER(t.name) LIKE '.$text;
                    $where                 = '(' . implode( ') OR (', $wheres2 ) . ')';*/
                    
                    $where                 = ' LOWER(v.value) LIKE LOWER('.$text.')';
                    break;
  
  //search all or any
            case 'all':
            case 'any':
  
  //set default
            default:
                    $words         = explode( ' ', $text );
                    $wheres = array();
                    foreach ($words as $word)
                    {
                            $word          = $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
                            $wheres2       = array();
                            $wheres2[]   = 'LOWER(v.value) LIKE LOWER('.$word.')';
                            /*$wheres2[]   = 'LOWER(p.name) LIKE '.$word;
                            $wheres2[]   = 'LOWER(t.info) LIKE '.$word;
                            $wheres2[]   = 'LOWER(t.name) LIKE '.$word;*/
                            $wheres[]    = implode( ' OR ', $wheres2 );
                    }
                    $where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
                    break;
    }
  
  //ordering of the results
    switch ( $ordering ) {
  
  //alphabetic, ascending
            case 'alpha':
                    $order = 'v.value ASC';
                    break;
  
  //oldest first
            case 'oldest':
  
  //popular first
            case 'popular':
  
  //newest first
            case 'newest':
  
  //default setting: alphabetic, ascending
            default:
                    $order = 'v.value ASC';
    }
  
  //replace nameofplugin
    $searchtarget = JText::_( 'ListManager' );
  
  //the database query; differs per situation! It will look something like this:
    $query = 'select distinct l.name as title,l.id as id,l.info as text,m.params as params, '
    . ' "1" AS browsernav'
    . ' from #__listmanager_listing l,#__listmanager_field f,#__listmanager_values v,#__modules m'  
    . ' WHERE l.id=f.idlisting and f.id=v.idfield and ( '. $where .' )'   
    . ' and m.module=\'mod_listmanager\' and m.published=1 and m.params like CONCAT(\'%"prefsids":"\',l.id,\'"%\')'
    . ' and m.params like \'%"searchable":"1"%\'' 
    . ' union'
    . ' select distinct l.name as title,l.id as id,l.info as text,m.params as params, '
    . ' "1" AS browsernav'
    . ' from #__listmanager_listing l,#__listmanager_field f,#__listmanager_values v,#__menu m,#__extensions e'  
    . ' WHERE e.extension_id=m.component_id and l.id=f.idlisting and f.id=v.idfield and ( '. $where .' )'   
    . ' and e.element=\'com_listmanager\' and m.published=1 and m.params like CONCAT(\'%"prefsids":"\',l.id,\'"%\')'
    . ' and m.params like \'%"searchable":"1"%\'' 
    //. ' ORDER BY '. $order
    ;
  
  //Set query
    $db->setQuery( $query, 0, $limit );
    $rows = $db->loadObjectList();
    
    
    // Views    
    $query = 'select distinct l.name as title,l.id as id,l.comments as text,m.params as params, '
    . ' "1" AS browsernav,if(m.params like \'%"access_type":"1"%\',1,0) as access_type, l.idlisting '
    . ' from #__listmanager_view l,#__listmanager_field f,#__listmanager_values v,#__modules m'  
    . ' WHERE l.idlisting=f.idlisting and f.id=v.idfield and ( '. $where .' )'   
    . ' and m.module=\'mod_listmanager\' and m.published=1 and m.params like CONCAT(\'%"prefsids":"v_\',l.id,\'"%\')'
    . ' and m.params like \'%"searchable":"1"%\'' 
    . ' union'
    . ' select distinct l.name as title,l.id as id,l.comments as text,m.params as params, '
    . ' "1" AS browsernav ,if(m.params like \'%"access_type":"1"%\',1,0) as access_type, l.idlisting ' 
    . ' from #__listmanager_view l,#__listmanager_field f,#__listmanager_values v,#__menu m,#__extensions e'  
    . ' WHERE e.extension_id=m.component_id and l.idlisting=f.idlisting and f.id=v.idfield and ( '. $where .' )'   
    . ' and e.element=\'com_listmanager\' and m.published=1 and m.params like CONCAT(\'%"prefsids":"v_\',l.id,\'"%\')'
    . ' and m.params like \'%"searchable":"1"%\'' 
    //. ' ORDER BY '. $order
    ;
    
    $db->setQuery( $query, 0, $limit );
    $rowsModule = $db->loadObjectList();
    
    foreach($rowsModule as $key => $row) {
    	$view=$rowsModule[$key];
    	$fieldsView=$this->getFieldsView($view->id);
    	//filtro permisos
      $arrdescartes=array(-1);
      $access_type=$view->access_type;
      $user_on=JUser::getInstance()->id;
      $result=array();
      $queryRecords = $this->_buildQueryRecords($view->idlisting);
      $db->setQuery($queryRecords);
      $arrRecords=$db->loadAssocList();
      foreach ($arrRecords as $rec) {            
	      //si hay que filtrar por usuario, hacerlo aqui (access_type, user_on))
	      if($rec['type']=='6'){	      
	        $result[$rec['idrecord']]['_struser']=& JFactory::getUser($rec['value'])->name;
	        if($access_type=='1'&&$user_on!=$rec['value']){	        
	          $arrdescartes[]=$rec['idrecord'];	        
	        }
	      }
	      $result[$rec['idrecord']]['id']=$rec['idrecord'];
	      $result[$rec['idrecord']][$rec['idfield']]=$rec['value'];
          // View filtered
          if(isset($fieldsView[$rec['idfield']])){
          	$view_field=$fieldsView[$rec['idfield']];
          	switch ($view_field->filter_type){
          		case '0': // Equal
          				if ($rec['value']!=$view_field->filter_value)
          					$arrdescartes[]=$rec['idrecord'];	
          			break;
          		case '1': // Less
          				if ($rec['value']>$view_field->filter_value)
          					$arrdescartes[]=$rec['idrecord'];
          			break;
          		case '2': // More
          				if ($rec['value']<$view_field->filter_value)
          					$arrdescartes[]=$rec['idrecord'];
          			break;
          		case '3': // Starts with
          				if (strpos($rec['value'],$view_field->filter_value)>0 ||
          					strpos($rec['value'],$view_field->filter_value)===false)
          					$arrdescartes[]=$rec['idrecord'];
          			break;
          		case '4': // Contains
          				if (strpos($rec['value'],$view_field->filter_value)===false)
          					$arrdescartes[]=$rec['idrecord'];
          			break;
          		default:
          			break;
          	}          	
          }       
      }
      foreach($arrdescartes as $d){      
        unset($result[$d]);
      }  

      foreach($result as $val){
      	foreach ($val as $value){
	      	if (stripos($value, $text)!=false){
	    			$rows[]=$row;
	    			break;	
	    	}
      	}
      }    
    }
    
    //The 'output' of the displayed link
    
    foreach($rows as $key => $row) {
            $temp1=str_replace("{","",$rows[$key]->params);
            $temp2=str_replace("}","",$temp1);
            $p=explode(",",$temp2);
            
            $linki="";
            foreach($p as $param){
            
            $fparam=explode(':',$param);
			$name=$fparam[0];
             
              if($name=="\"link_search\""&&strlen($param)>16){
                $linki=substr($param,15,strlen($param)-16);
                //$linki=$param;
              }  
            }
            $linki=str_replace('\\', '', $linki);  
            if($linki!="")
              $rows[$key]->href = $linki; 
    } 
    
    //Return the search results in an array
    return $rows;
}

function _buildQueryView($idview){
  	 if (!is_numeric($idview)) JError::raiseError(500,JText::_('INTERNAL SERVER ERROR'));
      $query = "select * from #__listmanager_field_view where idview=".$idview;
      return $query;
  }
function _buildQueryRecords($id){    
      if (!is_numeric($id)) JError::raiseError(500,JText::_('INTERNAL SERVER ERROR'));    
      $query = "SELECT v.id,v.idfield,v.value,v.idrecord,f.type,f.decimal,f.order,f.size,f.name,f.visible,f.total, f.autofilter,f.defvalue 
      			FROM #__listmanager_values v,#__listmanager_field f
      			where f.id=v.idfield and  idlisting=".$id;     
      return $query;
  }
function getFieldsView($idview){
  	$db = JFactory::getDBO();
  	$query = $this->_buildQueryView($idview);
  	$db->setQuery($query);
    return $db->loadObjectList('idfield');
  }

}
