<?php
/**
 * @package     Joomla.Site
 * @subpackage  Templates.protostar
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

$app             = JFactory::getApplication();
$doc             = JFactory::getDocument();
$user            = JFactory::getUser();
$this->language  = $doc->language;
$this->direction = $doc->direction;

// Detecting Active Variables
$option   = $app->input->getCmd('option', '');
$view     = $app->input->getCmd('view', '');
$layout   = $app->input->getCmd('layout', '');
$task     = $app->input->getCmd('task', '');
$itemid   = $app->input->getCmd('Itemid', '');
$sitename = $app->get('sitename');

 

// front page selection 
$home =(JURI::getInstance()->toString()==JURI::base());

// Adjusting content width
if ($this->countModules('right') && $this->countModules('left'))		{$span = "six";}
elseif ($this->countModules('right') && !$this->countModules('left'))	{$span = "nine";}
elseif (!$this->countModules('right') && $this->countModules('left'))	{$span = "nine"; }

else
{ 	$span = "twelve"; }

if ($home):
// Adjusting content width - home page
 
if ($this->countModules('right-home') && $this->countModules('left')){$span = "six";}
elseif ($this->countModules('right-home') && !$this->countModules('left')) {	$span = "nine";}
elseif (!$this->countModules('right-home') && $this->countModules('left')) {	$span = "nine";}
else {	$span = "twelve";}

endif;

/*add class to body tag*/
   $menu = JSite::getMenu()->getActive();
   $pageclass = '';
   if (is_object($menu))
      $pageclass = $menu->params->get('pageclass_sfx');
   $active = Jfactory::getApplication()->getMenu()->getActive();
?>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-gb" lang="en-gb" dir="ltr">
<head>
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
	<jdoc:include type="head" />

<link href='http://fonts.googleapis.com/css?family=Open+Sans:400,700&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
	
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/s/css/font-awesome.min.css"> 		
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/s/skeleton.css?<?php echo rand(); ?>" type="text/css" />
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/s/s.css?<?php echo rand(); ?>" type="text/css" />	
	
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>

<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/js/css/owl.carousel.css" media="screen"> 
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/js/css/owl.transitions.css" media="screen">
<script src="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/js/owl.carousel.js"></script>
 	<!--[if lt IE 9]>
		<script src="<?php echo $this->baseurl; ?>/media/jui/js/html5.js"></script>
	<![endif]-->
</head>

<body class=" <?php echo $pageclass ? htmlspecialchars($pageclass) : 'default'; ?> item-<?php echo $itemid  ? htmlspecialchars($itemid ) : 'default'; ?>">

 
	 
<!-- Header -->
<header class="header">

			<div class="topRight">
				<?php if ($this->countModules('topRight')) : ?>
				<jdoc:include type="modules" name="topRight" style="none" />
				<?php endif; ?>		
			</div>

			<a class="logoLnk" href="<?php echo $this->baseurl; ?>"> <img id="logo" src="images/FESE-logo.png" alt="logo" /></a>
				<?php if ($this->countModules('topLeft')) : ?>
				<jdoc:include type="modules" name="topLeft" style="none" />
				<?php endif; ?>	
</header>
	<?php if ($this->countModules('mainNav')) : ?>
	<nav class="navigation orangeBg" role="navigation">
				<jdoc:include type="modules" name="mainNav" style="none" />
	</nav>
	<?php endif; ?>	
<div id="tainer" class="box">
	<?php if ($this->countModules('banner')) : ?>
			<div class="">
				<jdoc:include type="modules" name="banner" style="none" />
			</div>
	<?php endif; ?>
	<?php if ($home): ?>
		<?php if ($this->countModules('banner-home')) : ?>
			<div class="banner">
				<jdoc:include type="modules" name="banner-home" style="none" />
			</div>
		<?php endif; ?>
	<?php endif; ?>
			 
  	<?php if ($this->countModules('left')) : ?>
		<!-- Begin Sidebar -->
			<div id="left" class="columns three">
			  	<jdoc:include type="modules" name="left" style="xhtml" />
			</div>
	<?php endif; ?>
<main id="content" role="main" class="columns <?php echo $span; ?>">
				<!-- Begin Content -->
				<jdoc:include type="modules" name="inContentTop" style="none" />
				<jdoc:include type="message" />
				<jdoc:include type="component" />
				<jdoc:include type="modules" name="inContentBottom" style="none" />
				<!-- End Content -->
</main>
	<?php if ($this->countModules('right')) : ?>
				<!-- Begin Right Sidebar -->
			<div id="right" class="columns three">
				<jdoc:include type="modules" name="right" style="well" />
			</div>				
	<?php endif; ?>
	<?php if ($home): ?>
		<?php if ($this->countModules('right-home')) : ?>
				<!-- Begin Right Sidebar -->
			<div id="right" class="columns three">
				<jdoc:include type="modules" name="right-home" style="well" />
			</div>
		<?php endif; ?>
	<?php endif; ?>
    
	
	<?php if ($this->countModules('user1')) : ?>
				<!-- Begin Right Sidebar -->
				<jdoc:include type="modules" name="user1" style="well" />
	<?php endif; ?>
	
</div>	
	<!-- Footer -->
<footer class="footer" role="contentinfo">
				<jdoc:include type="modules" name="footer" style="none" />
		<a href="#top" id="back-top">Back to top</a>
</footer>
				<jdoc:include type="modules" name="debug" style="none" />
	<?php if ($home): ?>	
	<script type="text/javascript">
 
	   $('.owl-carousel').owlCarousel({
        items:1,
		loop:true,
		autoplay:true,
    autoplayTimeout:6000,
    autoplayHoverPause:true,
	dots:true,
   nav:true,
	navText: [
      "<i class='fa fa-angle-left fa-2x'></i>",
      "<i class='fa fa-angle-right fa-2x'></i>"
      ],
	    margin:50, stagePadding:20
     });


	  
	</script>
	<?php endif; ?>
	
	</body>
</html>
